
{-----------------------------------------------------------------------------
|
|  P R K B D . P A S
|
|  Dekodierung der Sondertasten
|
|  Author: Wolfgang Klein (DD0PZ), Bogenstr. 3, 5249 Roth (Westerwald)
|          Tel: 02682/8505  priv. , 02741/23080 dienstl.
|
+----------------------------------------------------------------------------}

Unit PRKBD;

{$A+}    { WORD-Ausrichtung }
{$B-}    { keine vollstndige bool'sche Auswertung }
{$E-}    { kein 80x87-Emul }
{$X-}    { keine erweiterte Syntax }
{$V-}    { keine berprfung von Var-Strings }
{$I+}    { I/O-Prfung ein }
{$O-}    { keine Overlay-Fhigkeit }

{$IFDEF OS2}
{$G+}           { 80286-Code bei OS/2 }
{$ENDIF}


Interface

TYPE  KeyCodes   = (_NUL, Alt_Q, Alt_W, Alt_E, Alt_R, Alt_T, Alt_Y, Alt_U,
                    Alt_I, Alt_O, Alt_P, Alt_A, Alt_S, Alt_D, Alt_F,
                    Alt_G, Alt_H, Alt_J, Alt_K, Alt_L, Alt_Z, Alt_X,
                    Alt_C, Alt_V, Alt_B, Alt_N, Alt_M,
                    F1, F2, F3, F4, F5, F6, F7, F8, F9, F10,
                    CHome, CUp, PgUp, CLeft, CRight, NumPlus, CEnd,
                    CDown, PgDn, Ins, Del,
                    Sh_F1, Sh_F2, Sh_F3, Sh_F4, Sh_F5, Sh_F6, Sh_F7,
                    Sh_F8, Sh_F9, Sh_F10,
                    Ctrl_F1, Ctrl_F2, Ctrl_F3, Ctrl_F4, Ctrl_F5, Ctrl_F6,
                    Ctrl_F7, Ctrl_F8, Ctrl_F9, Ctrl_F10,
                    Alt_F1, Alt_F2, Alt_F3, Alt_F4, Alt_F5, Alt_F6, Alt_F7,
                    Alt_F8, Alt_F9, Alt_F10,
                    Ctrl_PrtScr, Ctrl_CLeft, Ctrl_CRight, Ctrl_CEnd,
                    Ctrl_PgDn, Ctrl_CHome,
                    Alt_1, Alt_2, Alt_3, Alt_4, Alt_5, Alt_6, Alt_7,
                    Alt_8, Alt_9, Alt_0, Alt_SZ, Alt_HK,
                    Ctrl_PgUp, _Sonstige,
                    _Return, _Escape, _Backstep, _Tab, Sh_Tab, _Dummy);

Procedure GetKey (Var Key: Char; Var KC: KeyCodes);

Implementation

  Uses Dos,
       Crt;

{----------------------------------------------------------------------------}
{ Tastatur decodieren                                                        }
{----------------------------------------------------------------------------}

Procedure GetKey (Var Key: Char; Var KC: KeyCodes);
Begin
  Key := ReadKey;
  If Key = #0 THEN BEGIN
    Key := ReadKey;
    Case Ord (Key) of

       3: KC := _NUL;      { Ctrl-2 }
      15: KC := Sh_Tab;

      16: KC := Alt_Q;
      17: KC := Alt_W;
      18: KC := Alt_E;
      19: KC := Alt_R;
      20: KC := Alt_T;
      21: KC := Alt_Y;
      22: KC := Alt_U;
      23: KC := Alt_I;
      24: KC := Alt_O;
      25: KC := Alt_P;

      30: KC := Alt_A;
      31: KC := Alt_S;
      32: KC := Alt_D;
      33: KC := Alt_F;
      34: KC := Alt_G;
      35: KC := Alt_H;
      36: KC := Alt_J;
      37: KC := Alt_K;
      38: KC := Alt_L;

      44: KC := Alt_Z;
      45: KC := Alt_X;
      46: KC := Alt_C;
      47: KC := Alt_V;
      48: KC := Alt_B;
      49: KC := Alt_N;
      50: KC := Alt_M;

      59: KC := F1;
      60: KC := F2;
      61: KC := F3;
      62: KC := F4;
      63: KC := F5;
      64: KC := F6;
      65: KC := F7;
      66: KC := F8;
      67: KC := F9;
      68: KC := F10;

      71: KC := CHome;
      72: KC := CUp;
      73: KC := PgUp;
      75: KC := CLeft;
      77: KC := CRight;
      78: KC := NumPlus;
      79: KC := CEnd;
      80: KC := CDown;
      81: KC := PgDn;
      82: KC := Ins;
      83: KC := Del;

      84: KC := Sh_F1;
      85: KC := Sh_F2;
      86: KC := Sh_F3;
      87: KC := Sh_F4;
      88: KC := Sh_F5;
      89: KC := Sh_F6;
      90: KC := Sh_F7;
      91: KC := Sh_F8;
      92: KC := Sh_F9;
      93: KC := Sh_F10;

      94: KC := Ctrl_F1;
      95: KC := Ctrl_F2;
      96: KC := Ctrl_F3;
      97: KC := Ctrl_F4;
      98: KC := Ctrl_F5;
      99: KC := Ctrl_F6;
      100: KC := Ctrl_F7;
      101: KC := Ctrl_F8;
      102: KC := Ctrl_F9;
      103: KC := Ctrl_F10;

      104: KC := Alt_F1;
      105: KC := Alt_F2;
      106: KC := Alt_F3;
      107: KC := Alt_F4;
      108: KC := Alt_F5;
      109: KC := Alt_F6;
      110: KC := Alt_F7;
      111: KC := Alt_F8;
      112: KC := Alt_F9;
      113: KC := Alt_F10;

      114: KC := Ctrl_PrtScr;
      115: KC := Ctrl_CLeft;
      116: KC := Ctrl_CRight;
      117: KC := Ctrl_CEnd;
      118: KC := Ctrl_PgDn;
      119: KC := Ctrl_CHome;

      120: KC := Alt_1;
      121: KC := Alt_2;
      122: KC := Alt_3;
      123: KC := Alt_4;
      124: KC := Alt_5;
      125: KC := Alt_6;
      126: KC := Alt_7;
      127: KC := Alt_8;
      128: KC := Alt_9;
      129: KC := Alt_0;
      130: KC := Alt_SZ;  { Alt- }
      131: KC := Alt_HK;  { Alt-' }

      132: KC := Ctrl_PgUp;

    Else   KC := _Sonstige;
    End;
  End

  Else Begin
    Case Ord(Key) of
      13: KC := _Return;
      27: KC := _Escape;
       8: KC := _Backstep;
{      9: KC := _Tab;         }   { TAB soll man senden knnen }

     Else KC := _Sonstige;
    End;
  End;
End;

{----------------------------------------------------------------------------}
{  das wars's ...                                                            }
{----------------------------------------------------------------------------}

BEGIN

End.
